;#include "ti82.inc"
;#include "ti83.inc"
#include "ti83p.inc"
;#include "ti85.inc"
;#include "ti86.inc"

;************************

ContinuePrg:
 call ClrGrf
 ld hl,TitlePic
 call SetUp
 jp ContProg
 
SetUp:
 ld de,NewPic
 call DspRLE
 ld hl,_plotSScreen
 ld de,NewPic
 
FadeIn:
#ifdef SCR96
 ld b,6
#else
 ld b,8
#endif
 xor a
 ld (Val),a
 push hl
 push de
Loop1:
 push bc
 ld b,128
Loop:
 ld a,(de)
 cp (hl)
 jr z,Fin
 ld a,1
 ld (Val),a
 inc (hl)
 ld a,(de)
 cp (hl)
 jr z,Fin
 inc (hl)
Fin:
 inc hl
 inc de
 djnz Loop
 pop bc
 djnz Loop1
#ifdef SCR96
 call Cpy2Home
#endif
 pop de
 pop hl
 
 ld a,(Val)
 jr nz,FadeIn
 call Pauseit
 
 ld hl,_plotSScreen
FadeOut:
#ifdef SCR96
 ld b,6
#else
 ld b,8
#endif
 xor a
 ld (Val),a
 push hl
Loop3:
 push bc
 ld b,128
Loop2:
 ld a,(hl)
 or a
 jr z,Fin2
 ld a,1
 ld (Val),a
 dec (hl)
 ld a,(hl)
 or a
 jr z,Fin2
 dec (hl)
Fin2:
 inc hl
 djnz Loop2
 pop bc
 djnz Loop3
#ifdef SCR96
 call Cpy2Home
#endif
 pop hl
 ld a,(Val)
 jr nz,FadeOut
 ret
 
Pauseit:
 call GET_KEY
 or a
 jr z,Pauseit
 ret
 
DspRLE:
#ifdef SCR96
 ld bc,768
#else
 ld bc,1024
#endif
DispRLEL:
 ld a,(hl)
 cp $91
 jr z,DispRLERun
 ldi
DispRLEC:
 ld a,b
 or c
 jr nz,DispRLEL
 ret
DispRLERun:
 inc hl
 ld a,(hl)
 inc hl
 push hl
 ld h,(hl)
 ex de,hl
DispRLERunL:
 ld (hl),a
 inc hl
 dec bc
 dec d
 jr nz,DispRLERunL
 ex de,hl
 pop hl
 inc hl
 jr DispRLEC
 
Black_Band:
 bcall(_ClrScrn)
#ifdef SCR96
 ld hl,_plotSScreen+696
 ld de,_plotSScreen+697
 ld bc,$47
#else
 ld hl,$FFA0
 ld de,$FFA1
 ld bc,$5F
#endif
 ld (hl),$FF
 ldir
#ifdef SCR96
 jp Cpy2Home
#else
 ret
#endif

ClrGrf:
 bcall(_ClrScrn)
 ld hl,_plotSScreen
 ld de,_plotSScreen+1
 ld (hl),0
 ld bc,767
 ldir
#ifdef SCR96
 jp Cpy2Home
#else
 ret
#endif
 
ShowBig:
 ld a,c
 ld (CURSOR_ROW),a
 ld a,b
 ld (CURSOR_COL),a
 bjump(_PutS)
 
ShowSmall:
 ld a,c
 ld (CURSOR_X),a
 ld a,b
 ld (CURSOR_Y),a
 bjump(_VPutS)
 
ContProg:
 call Black_Band
 call InvText
 ld hl,stars
 ld bc,$0001
 call ShowBig
 ld hl,text
 inc c
 call ShowBig
 inc c
 call ShowBig
 ld hl,stars
 inc c
 call ShowBig
 ld hl,Menu
 ld bc,$3A00
 call ShowSmall
 ld c,$10
 call ShowSmall
 ld c,$2A
 call ShowSmall
 ld c,$3C
 call ShowSmall
 ld c,$50
 call ShowSmall
 call InvText

MainKeyLoop:
 ld a,$FF
 out (1),a
 ld a,$BF
 out (1),a
 in a,(1)
 bit 4,a ; y= or F1
 jp z,StartGame
 bit 3,a ; window or F2
 jr z,Credits
 bit 2,a ;zoom or F3
 jr z,Help
 bit 1,a ;trace or F4
 jr z,About
 bit 0,a ; graph or F5
 jp z,EXIT
 jr MainKeyLoop

Credits:
 bcall(_ClrScrn)
 ld hl,people
 call InvText
 ld bc,$0000
 call ShowBig
 ld c,$05
 call ShowBig
 call InvText
 ld bc,$0A00
 call ShowSmall
 ld b,$12
 call ShowSmall
 ld b,$1A
 call ShowSmall
 ld b,$30
 call ShowSmall
 call Pauseit
 jp ContProg

Help:
 bcall(_ClrScrn)
 ld hl,stuff
 call InvText
 ld bc,$0000
 call ShowBig
 call InvText
 ld b,$0D
 call ShowSmall
 ld b,$15
 call ShowSmall
 ld b,$1D
 call ShowSmall
 ld b,$25
 call ShowSmall
 ld b,$2D
 call ShowSmall
 call Pauseit
 jp ContProg

About:
 bcall(_ClrScrn)
 ld hl,IntroText
 ld bc,$0000
 call ShowSmall
 ld b,$08
 call ShowSmall
 ld b,$10
 call ShowSmall
 ld b,$18
 call ShowSmall
 ld b,$20
 call ShowSmall
 call InvText
 ld b,$30
 call ShowSmall
 call InvText
 call Pauseit
 jp ContProg

InvText:
 bit 3,(iy+5)
 jr nz,ResText
 set 3,(iy+5)
 ret
ResText:
 res 3,(iy+5)
 ret
 
StartGame:
 call ClrGrf
 ld a,1
 ld (play1_op),a
 ld (play2_op),a
 ld hl,Vegeta
 call LoadP1
 ld hl,Char1
 ld de,P_Op1
 ld bc,10
 ldir
 ld hl,Vegeta
 call LoadP2
 ld hl,Char1
 ld de,P_Op2
 ld bc,10
 ldir
 jr Player1
 
Load_POp1:
 ld de,P_Op2
 ldir
 
Player1:
 call InvText
 call Show_POp1
 call InvText
 call Show_POp2
Play1_2:
 ld a,$FF
 out (1),a
 ld a,$FE
 out (1),a
 in a,(1)
 bit 3,a
 jp z,Player2
 bit 2,a
 jr z,IncPlay1
 bit 1,a
 jr z,DecPlay1
 ld a,$FF
 out (1),a
 ld a,$FD
 out (1),a
 in a,(1)
 bit 0,a
 jp z,Really_Start
; cp kLOG
; jr z,Cart1
; cp kSIN
; jr z,Friz1
; cp kTAN
; jr z,Buu1
 jr Play1_2
 
Show_POp2:
 ld hl,P_Op2
 ld bc,$0001
 jp ShowBig

Show_POp1:
 ld hl,P_Op1
 ld bc,$0000
 jp ShowBig
 
IncPlay1:
 ld a,(play1_op)
 cp 8
 jr z,Player1
 inc a
 ld (play1_op),a
 cp 8
 jr z,Got1
 jr Play1_1
 
DecPlay1:
 ld a,(play1_op)
 cp 1
 jr z,Player1
 dec a
 ld (play1_op),a
 cp 1
 jr z,Vp1
Play1_1:
 cp 2
 jr z,Gp1
 cp 3
 jr z,G3p1
 cp 5
 jp z,Tp1
 cp 4
 jr z,Hp1
 cp 6
 jp z,Raditz1
 cp 7
 jr z,GGtp1
 jp Player1
 
Got1:
 call Clear_Char1
 ld hl,Gotenks
 call LoadP1
 ld hl,Gotnk
 ld bc,7
 jp Load_POp1
 
Vp1:
 call Clear_Char1
 ld hl,Vegeta
 call LoadP1
 ld hl,Char1
 ld bc,10
 jp Load_POp1
 
GGtp1:
 call Clear_Char1
 ld hl,GokuGT
 call LoadP1
 ld hl,GGtText
 ld bc,13
 jp Load_POp1
 
Friz1:
 call Clear_Char1
 ld hl,Frieza
 call LoadP1
 ld hl,CharF
 ld bc,6
 jp Load_POp1
 
Gp1:
 call Clear_Char1
 ld hl,Kakarot
 call LoadP1
 ld hl,Char2
 ld bc,8
 jp Load_POp1

G3p1:
 call Clear_Char1
 ld hl,SSJ3_Goku
 call LoadP1
 ld hl,Char4
 ld bc,10
 jp Load_POp1
 
Hp1:
 call Clear_Char1
 ld hl,Gohan
 call LoadP1
 ld hl,Char5
 ld bc,9
 jp Load_POp1

Tp1:
 call Clear_Char1
 ld hl,Trunks
 call LoadP1
 ld hl,Char6
 ld bc,10
 jp Load_POp1
 
Cart1:
 call Clear_Char1
 ld hl,cartman
 call LoadP1
 ld hl,Cart
 ld bc,12
 jp Load_POp1
 
Raditz1:
 call Clear_Char1
 ld hl,Raditz
 call LoadP1
 ld hl,Rad
 ld bc,6
 jp Load_POp1

Buu1:
 call Clear_Char1
 ld hl,Buu
 call LoadP1
 ld hl,Majin
 ld bc,9
 jp Load_POp1
 
LoadP1:
 ld de,play1
 ld bc,56
 ldir
 ld hl,CleanChar
 ld de,P_Op2
 ld bc,13
 ldir
Clear_Char1:
 xor b
 ld c,$24
 ld ix,play1
 call PutSprite
#ifdef SCR96
 jp Cpy2Home
#else
 ret
#endif
 
Load_POp2:
 ld de,P_Op2
 ldir
 
Player2:
 call Show_POp1
 call InvText
 call Show_POp2
 call InvText
Play2_2:
 ld a,$FF
 out (1),a
 ld a,$FE
 out (1),a
 in a,(1)
 bit 3,a
 jp z,Player1
 bit 2,a
 jr z,IncPlay2
 bit 1,a
 jr z,DecPlay2
 ld a,$FF
 out (1),a
 ld a,$FD
 out (1),a
 in a,(1)
 bit 0,a
 jp z,Really_Start
; cp kLOG
; jr z,Cart2
; cp kTAN
; jr z,Buu2
; cp kSIN
; jr z,Friz2
 jr Play2_2
 
IncPlay2:
 ld a,(play2_op)
 cp 8
 jr z,Player2
 inc a
 ld (play2_op),a
 cp 8
 jr z,Got2
 jr Play2_1

DecPlay2:
 ld a,(play2_op)
 cp 1
 jr z,Player2
 dec a
 ld (play2_op),a
 cp 1
 jr z,Vp2
Play2_1:
 cp 2
 jr z,Gp2
 cp 4
 jp z,Hp2
 cp 3
 jr z,G3p2
 cp 5
 jp z,Tp2
 cp 6
 jr z,GGtp2
 cp 7
 jp z,Raditz2
 jr Player2
 
Got2:
 call Clear_Char2
 ld hl,Gotenks
 call LoadP2
 ld hl,Gotnk
 ld bc,7
 jp Load_POp2
 
GGtp2:
 call Clear_Char2
 ld hl,GokuGT
 call LoadP2
 ld hl,GGtText
 ld bc,13
 jp Load_POp2
 
Friz2:
 call Clear_Char2
 ld hl,Frieza
 call LoadP2
 ld hl,CharF
 ld bc,6
 jp Load_POp2
 
Vp2:
 call Clear_Char2
 ld hl,Vegeta
 call LoadP2
 ld hl,Char1
 ld bc,10
 jp Load_POp2
 
Gp2:
 call Clear_Char2
 ld hl,Kakarot
 call LoadP2
 ld hl,Char2
 ld bc,8
 jp Load_POp2

Cart2:
 call Clear_Char2
 ld hl,cartman
 call LoadP2
 ld hl,Cart
 ld bc,12
 jp Load_POp2

G3p2:
 call Clear_Char2
 ld hl,SSJ3_Goku
 call LoadP2
 ld hl,Char4
 ld bc,10
 jp Load_POp2
 
Hp2:
 call Clear_Char2
 ld hl,Gohan
 call LoadP2
 ld hl,Char5
 ld bc,9
 jp Load_POp2

Tp2:
 call Clear_Char2
 ld hl,Trunks
 call LoadP2
 ld hl,Char6
 ld bc,10
 jp Load_POp2
 
Raditz2:
 call Clear_Char2
 ld hl,Raditz
 call LoadP2
 ld hl,Rad
 ld bc,6
 jp Load_POp2

Buu2:
 call Clear_Char2
 ld hl,Buu
 call LoadP2
 ld hl,Majin
 ld bc,9
 jp Load_POp2
 
LoadP2:
 ld de,play2
 ld bc,56
 ldir
 ld hl,play2
 ld b,56
 call Reverse_Sprite
 ld ix,play2
 ld b,28
 call Rev16
 ld hl,CleanChar
 ld de,P_Op2
 ld bc,13
 ldir
Clear_Char2:
 ld bc,$5024
 ld ix,play2
 call PutSprite
#ifdef SCR96
 jp Cpy2Home
#else
 ret
#endif
 
Reverse_Sprite:
 ld c,(hl)
 call FixC2
 call FixC2
 call FixC2
 call FixC2
 ld (hl),a
 inc hl
 djnz Reverse_Sprite
 ret

FixC2:
 rlc c
 rra
 rlc c
 rra
 ret

Rev16:
 ld d,(ix)
 ld e,(ix+1)
 ld (ix),e
 ld (ix+1),d
 inc ix
 inc ix
 djnz Rev16
 ret

PauseGame:
 call GET_KEY
 jr GameKeyLoop
 
Really_Start:
 call ClrGrf
 call Black_Band
 ld bc,$0505
 ld (Vegetaxy),bc
 ld (VegetaxyOld),bc
 ld ix,play1
 call PutSprite
 xor a
 ld (IsFire),a
 ld bc,$4F05
 ld (Kakarotxy),bc
 ld (KakarotxyOld),bc
 ld ix,play2
 call PutSprite
 xor a
 ld (IsFireG),a
 ld a,30
 ld (VegetaP),a
 ld a,65
 ld (KakarotP),a
 xor a
 ld (Kakarot_counter),a

GameKeyLoop:
very_hard_mode:
 ld a,$FF
 out (1),a
 ld a,$FE
 out (1),a
 in a,(1)
 bit 3,a
 push af
 call z,MoveUP
 pop af
 bit 2,a
 push af
 call z,MoveRIGHT
 pop af
 bit 1,a
 push af
 call z,MoveLEFT
 pop af
 bit 0,a
 call z,MoveDOWN
 ld a,63
 out (1),a
 in a,(1)
 bit 5,a
 push af
 call z,Fire
 pop af
 bit 7,a
 jr z,PauseGame
 bit 6,a
 call z,EXIT
#ifdef SCR96
 call Cpy2Home
#endif
 call moveFireball

Moves_Kakarot_Randomly:
very_hard_mode2:
 call KakarotFIRES
 ld a,(Kakarot_counter)
 or a
 jr z,new_direction
 ld a,(Kakarot_direction)
 cp 1
 call z,MoveKakarotLeft
 ld a,(Kakarot_direction)
 cp 2
 call z,MoveKakarotRight
 ld a,(Kakarot_direction)
 cp 3
 call z,MoveKakarotUp
 ld a,(Kakarot_direction)
 cp 4
 call z,MoveKakarotDown
 ld hl,Kakarot_counter
 dec (hl)
 jr GameKeyLoop
new_direction:
 ld a,r
 and 3
 inc a
 ld (Kakarot_direction),a
 ld a,10
 ld (Kakarot_counter),a
 jr GameKeyLoop

KakarotFIRES:
 call FireG
 jp moveFireballG
 
MoveKakarotUp:
 ld bc,(Kakarotxy)
 dec c
 ld a,c
 cp 255
 ret z
 ld (Kakarotxy),bc
 jr moveKakarot

MoveKakarotDown:
 ld bc,(Kakarotxy)
 inc c
 ld a,c
 cp 31
 ret nc
 ld (Kakarotxy),bc
 jr moveKakarot

MoveKakarotRight:
 ld bc,(Kakarotxy)
 inc b
 ld a,b
 cp $50
 ret z
 ld (Kakarotxy),bc
 jr moveKakarot
 
MoveKakarotLeft:
 ld bc,(Kakarotxy)
 dec b
 ld a,b
 cp $30
 ret z
 ld (Kakarotxy),bc

moveKakarot:
 ld bc,(KakarotxyOld)
 ld ix,play2
 call PutSprite
 ld bc,(Kakarotxy)
 ld (KakarotxyOld),bc
 ld ix,play2
 jp PutSprite
 
MoveRIGHT:
 ld bc,(Vegetaxy)
 inc b
 ld a,b
 cp $20
 ret z
 ld (Vegetaxy),bc
 jr moveVegeta

MoveUP:
 ld bc,(Vegetaxy)
 dec c
 ld a,c
 cp 255
 ret z
 ld (Vegetaxy),bc
 jr moveVegeta

MoveDOWN:
 ld bc,(Vegetaxy)
 inc c
 ld a,c
 cp 31
 ret nc
 ld (Vegetaxy),bc
 jr moveVegeta

MoveLEFT:
 ld bc,(Vegetaxy)
 dec b
 ld a,b
 or a
 ret z
 ld (Vegetaxy),bc

moveVegeta:
 ld bc,(VegetaxyOld)
 ld ix,play1
 call PutSprite
 ld bc,(Vegetaxy)
 ld (VegetaxyOld),bc
 ld ix,play1
 jp PutSprite
 
Fire:
 ld hl,IsFire
 xor a
 cp (hl)
 ret nz
 ld (hl),1
 ld hl,(Vegetaxy)
 ld de,$0811
 add hl,de
 ld b,h
 ld c,l
 ld (Firexy),bc
 ld (FirexyOld),bc
 ld ix,Fireball
 jp PutIt

FireG:
 ld hl,IsFireG
 xor a
 cp (hl)
 ret nz
 ld (hl),1
 ld hl,(Kakarotxy)
 ld a,l
 add a,11
 ld c,a
 ld a,h
 sub 8
 ld b,a
 ld (FireGxy),bc
 ld (FireGxyOld),bc
 ld ix,Fireball2
 jp PutIt

moveFireball:
 ld hl,IsFire
 xor a
 cp (hl)
 ret z
 ld bc,(Firexy)
 inc b
 inc b
 ld a,79
 cp b
 jr c,fire_hit_wall
 ld (Firexy),bc
 push bc
 call Collision_Detection
 ld bc,(FirexyOld)
 ld ix,Fireball
 push ix
 call PutIt
 pop ix
 pop bc
 ld (FirexyOld),bc
 jp PutIt

moveFireballG:
 ld hl,IsFireG
 xor a
 cp (hl)
 ret z
 ld bc,(FireGxy)
 dec b
 dec b
 ld a,1
 cp b
 jr nc,fire_hit_wallG
 ld (FireGxy),bc
 push bc
 call Collision_DetectionG
 ld bc,(FireGxyOld)
 ld ix,Fireball2
 push ix
 call PutIt
 pop ix
 pop bc
 ld (FireGxyOld),bc
 jp PutIt

fire_hit_wall:
 ld bc,(FirexyOld)
 ld ix,Fireball
 call PutIt
 xor a
 ld (IsFire),a
 ret

fire_hit_wallG:
 ld bc,(FireGxyOld)
 ld ix,Fireball2
 call PutIt
 xor a
 ld (IsFireG),a
 ret
 
Winner:
 call ClrGrf
 ld hl,WinPic
 call SetUp
 jp ContinuePrg
 
EXIT:
 call ClrGrf
 res 3,(iy+35)
 jp EXIT_2_TIOS

#include "sprite82.asm"
#include "data96.asm"
 
.end