.plugin asm86

#include "RBP2.inc"
;#include "86txt16.inc"

.org $D748

 nop
 jp ContinuePrg
.dw 2,ShellTitle,Shell_ICON

SetUp:
 ld de,$F700
 call DspRLE
 ld hl,$FC00
 ld de,$F700
 
FadeIn:
 ld b,8
 xor a
 ld (Val),a
 push hl
 push de
Loop1:
 push bc
 ld b,128
Loop:
 ld a,(de)
 cp (hl)
 jr z,Fin
 ld a,1
 ld (Val),a
 inc (hl)
 ld a,(de)
 cp (hl)
 jr z,Fin
 inc (hl)
Fin:
 inc hl
 inc de
 djnz Loop
 pop bc
 djnz Loop1
 pop de
 pop hl
 ld a,(Val)
 jr nz,FadeIn
 
 call _getkey
 
 ld hl,$FC00
FadeOut:
 ld b,8
 xor a
 ld (Val),a
 push hl
Loop3:
 push bc
 ld b,128
Loop2:
 ld a,(hl)
 or a
 jr z,Fin2
 ld a,1
 ld (Val),a
 dec (hl)
 ld a,(hl)
 or a
 jr z,Fin2
 dec (hl)
Fin2:
 inc hl
 djnz Loop2
 pop bc
 djnz Loop3
 pop hl
 ld a,(Val)
 jr nz,FadeOut
 ret
 
DspRLE:
 ld bc,1024
DispRLEL:
 ld a,(hl)
 cp $91
 jr z,DispRLERun
 ldi
DispRLEC:
 ld a,b
 or c
 jr nz,DispRLEL
 ret
DispRLERun:
 inc hl
 ld a,(hl)
 inc hl
 push hl
 ld h,(hl)
 ex de,hl
DispRLERunL:
 ld (hl),a
 inc hl
 dec bc
 dec d
 jr nz,DispRLERunL
 ex de,hl
 pop hl
 inc hl
 jr DispRLEC
 
PauseGame:
 call _getkey
 jp GameKeyLoop

c_up:
 ld a,1
 jr c_main
c_down:
 ld a,-1
c_main:
 ld hl,_contrast ; get the current contrast
 add a,(hl) ; add either 1 or substract 1 depending on mode
 and 31 ; make sure it's within the boundaries
 ld (hl),a ; set the RAM location
 out (2),a ; tell the display to update the contrast
 ret
 
ClrBG:
 call _clrLCD
 ld hl,$FC00
 ld de,$F700
 ld bc,$400
 ldir
 ret
  
Black_Band:
 call _clrScrn
 ld hl,$FFA0
 ld de,$FFA1
 ld (hl),$FF
 ld bc,$5F
 ldir
 ret

ShowBig:
 ld (_curRow),bc
 jp _puts
 
ShowSmall:
 ld (_penCol),bc
 jp _vputs
 
ContinuePrg:
 call _runIndicOff
 call _clrScrn
 ld hl,TitlePic
 call SetUp
 
ContProg:
 call Black_Band
 call InvText
 ld hl,stars
 ld bc,$0002
 call ShowBig
 ld hl,text
 inc c
 call ShowBig
 ld hl,stars
 inc c
 call ShowBig
 ld hl,Menu
 ld bc,$3A01
 call ShowSmall
 ld c,$18
 call ShowSmall
 ld c,$39
 call ShowSmall
 ld c,$54
 call ShowSmall
 ld c,$70
 call ShowSmall
 call InvText

MainKeyLoop:
 call _GetKy
 cp K_EXIT
 jp z,EXIT
 cp K_PLUS
 call z,c_up
 cp K_MINUS
 call z,c_down
 cp K_F2
 jr z,Credits
 cp K_F3
 jr z,Help
 cp K_F4
 jr z,About
 cp K_F5
 jp z,EXIT
 cp K_F1
 jp z,StartGame
 jr MainKeyLoop

Credits:
 call _clrScrn
 ld hl,people
 call InvText
 xor b
 xor c
 call ShowBig
 ld c,$04
 call ShowBig
 call InvText
 ld bc,$0D00
 call ShowSmall
 ld b,$15
 call ShowSmall
 ld b,$32
 call ShowSmall
 call _getkey
 jp ContProg

Help:
 call _clrScrn
 ld hl,stuff
 call InvText
 xor b
 xor c
 call ShowBig
 call InvText
 ld b,$0D
 call ShowSmall
 ld b,$15
 call ShowSmall
 ld b,$1D
 call ShowSmall
 ld b,$25
 call ShowSmall
 ld b,$2D
 call ShowSmall
 call _getkey
 jp ContProg

About:
 call _clrScrn
 ld hl,IntroText
 xor b
 xor c
 call ShowSmall
 ld b,$08
 call ShowSmall
 ld b,$10
 call ShowSmall
 ld b,$18
 call ShowSmall
 call InvText
 ld b,$28
 call ShowSmall
 call InvText
 call _getkey
 jp ContProg

InvText:
 bit 3,(iy+5)
 jr nz,ResText
 set 3,(iy+5)
 ret
ResText:
 res 3,(iy+5)
 ret
 
StartGame:
 call _clrScrn
 call OpenGray
 call ClrBG
 call _runIndicOff
 ld a,1
 ld (play1_op),a
 ld (play2_op),a
 ld hl,Vegeta
 call LoadP1

 ld hl,Char1
 ld de,P_Op2
 ld bc,10
 ldir

 ld hl,Vegeta
 call LoadP2
 ld hl,Char1
 ld de,P_Op3
 ld bc,10
 ldir

 xor a
 ld de,$1000
 call DispA

Difficulty:
 call Show_POp2
 call Show_POp3
 call InvText
 call Show_POp1
 call InvText
Diff_2:
 call _GetKy
 cp K_RIGHT
 jr z,IncDiff
 cp K_LEFT
 jr z,DecDiff
 cp K_DOWN
 jr z,Player1
 cp K_ENTER
 jp z,Really_Start
 cp K_UP
 jp z,Player2
 jr Diff_2
 
Show_POp2:
 ld hl,P_Op2
 ld bc,$0001
 jp ShowBig
 
Show_POp3:
 ld hl,P_Op3
 ld bc,$0002
 jp ShowBig

Show_POp1:
 ld hl,P_Op1
 ld bc,$0000
 jp ShowBig
 
IncDiff:
 ld a,(difficulty_mode)
 cp 2
 jr z,Difficulty
 inc a
 call Set_Diff
 
DecDiff:
 ld a,(difficulty_mode)
 or a
 jr z,Difficulty
 dec a
Set_Diff:
 ld (difficulty_mode),a
 ld de,$1000
 
DispA:
 inc a
 ld l,a
 ld h,0
 xor a
 ld (_curRow),de
 call $4A33
 call _vputs
 jr Difficulty
 
Load_POp2:
 ld de,P_Op2
 ldir
 
Player1:
 call Show_POp1
 call Show_POp3
 call InvText
 call Show_POp2
 call InvText
Play1_2:
 call _GetKy
 cp K_UP
 jp z,Difficulty
 cp K_RIGHT
 jr z,IncPlay1
 cp K_LEFT
 jr z,DecPlay1
 cp K_ENTER
 jp z,Really_Start
 cp K_DOWN
 jp z,Player2
 cp K_LOG
 jp z,Cart1
 cp K_SIN
 jp z,Friz1
 cp K_TAN
 jp z,Buu1
 jr Play1_2
 
IncPlay1:
 ld a,(play1_op)
 cp 8
 jr z,Player1
 inc a
 ld (play1_op),a
 cp 8
 jp z,Got1
 jr Play1_1
 
DecPlay1:
 ld a,(play1_op)
 cp 1
 jp z,Player1
 dec a
 ld (play1_op),a
 cp 1
 jr z,Vp1
Play1_1:
 cp 2
 jr z,Gp1
 cp 3
 jr z,G3p1
 cp 5
 jp z,Tp1
 cp 4
 jr z,Hp1
 cp 6
 jp z,Raditz1
 cp 7
 jp z,GGtp1
 jp Player1
 
Got1:
 call Clear_Char1
 ld hl,Gotenks
 call LoadP1
 ld hl,Gotnk
 ld bc,7
 call Load_POp2
 
Vp1:
 call Clear_Char1
 ld hl,Vegeta
 call LoadP1
 ld hl,Char1
 ld bc,10
 call Load_POp2
 
GGtp1:
 call Clear_Char1
 ld hl,GokuGT
 call LoadP1
 ld hl,GGtText
 ld bc,13
 call Load_POp2
 
Friz1:
 call Clear_Char1
 ld hl,Frieza
 call LoadP1
 ld hl,CharF
 ld bc,6
 call Load_POp2
 
Gp1:
 call Clear_Char1
 ld hl,Kakarot
 call LoadP1
 ld hl,Char2
 ld bc,8
 call Load_POp2

G3p1:
 call Clear_Char1
 ld hl,SSJ3_Goku
 call LoadP1
 ld hl,Char4
 ld bc,10
 call Load_POp2
 
Hp1:
 call Clear_Char1
 ld hl,Gohan
 call LoadP1
 ld hl,Char5
 ld bc,9
 call Load_POp2

Tp1:
 call Clear_Char1
 ld hl,Trunks
 call LoadP1
 ld hl,Char6
 ld bc,10
 call Load_POp2
 
Cart1:
 call Clear_Char1
 ld hl,cartman
 call LoadP1
 ld hl,Cart
 ld bc,12
 call Load_POp2
 
Raditz1:
 call Clear_Char1
 ld hl,Raditz
 call LoadP1
 ld hl,Rad
 ld bc,6
 call Load_POp2

Buu1:
 call Clear_Char1
 ld hl,Buu
 call LoadP1
 ld hl,Majin
 ld bc,9
 call Load_POp2
 
LoadP1:
 ld de,play1+2
 ld bc,56
 ldir
 ld hl,CleanChar
 ld de,P_Op2
 ld bc,18
 ldir
Clear_Char1:
 xor b
 ld c,$24
 ld hl,play1
 jp PutSprite16
 
Load_POp3:
 ld de,P_Op3
 ldir
 
Player2:
 call Show_POp2
 call Show_POp1
 call InvText
 call Show_POp3
 call InvText
Play2_2:
 call _GetKy
 cp K_UP
 jp z,Player1
 cp K_RIGHT
 jr z,IncPlay2
 cp K_LEFT
 jr z,DecPlay2
 cp K_DOWN
 jp z,Difficulty
 cp K_SIN
 jp z,Friz2
 cp K_ENTER
 jp z,Really_Start
 cp K_LOG
 jp z,Cart2
 cp K_TAN
 jp z,Buu2
 jr Play2_2
 
IncPlay2:
 ld a,(play2_op)
 cp 8
 jr z,Player2
 inc a
 ld (play2_op),a
 cp 8
 jr z,Got2
 jr Play2_1

DecPlay2:
 ld a,(play2_op)
 cp 1
 jr z,Player2
 dec a
 ld (play2_op),a
 cp 1
 jr z,Vp2
Play2_1:
 cp 2
 jr z,Gp2
 cp 4
 jp z,Hp2
 cp 3
 jr z,G3p2
 cp 5
 jp z,Tp2
 cp 6
 jr z,GGtp2
 cp 7
 jp z,Raditz2
 jp Player2
 
Got2:
 call Clear_Char2
 ld hl,Gotenks
 call LoadP2
 ld hl,Gotnk
 ld bc,7
 call Load_POp3
 
GGtp2:
 call Clear_Char2
 ld hl,GokuGT
 call LoadP2
 ld hl,GGtText
 ld bc,13
 call Load_POp3
 
Friz2:
 call Clear_Char2
 ld hl,Frieza
 call LoadP2
 ld hl,CharF
 ld bc,6
 call Load_POp3
 
Vp2:
 call Clear_Char2
 ld hl,Vegeta
 call LoadP2
 ld hl,Char1
 ld bc,10
 call Load_POp3
 
Gp2:
 call Clear_Char2
 ld hl,Kakarot
 call LoadP2
 ld hl,Char2
 ld bc,8
 call Load_POp3

Cart2:
 call Clear_Char2
 ld hl,cartman
 call LoadP2
 ld hl,Cart
 ld bc,12
 call Load_POp3

G3p2:
 call Clear_Char2
 ld hl,SSJ3_Goku
 call LoadP2
 ld hl,Char4
 ld bc,10
 call Load_POp3
 
Hp2:
 call Clear_Char2
 ld hl,Gohan
 call LoadP2
 ld hl,Char5
 ld bc,9
 call Load_POp3

Tp2:
 call Clear_Char2
 ld hl,Trunks
 call LoadP2
 ld hl,Char6
 ld bc,10
 call Load_POp3
 
Raditz2:
 call Clear_Char2
 ld hl,Raditz
 call LoadP2
 ld hl,Rad
 ld bc,6
 call Load_POp3

Buu2:
 call Clear_Char2
 ld hl,Buu
 call LoadP2
 ld hl,Majin
 ld bc,9
 call Load_POp3
 
LoadP2:
 ld de,play2+2
 ld bc,56
 ldir
 ld hl,play2+2
 ld b,56
 call Reverse_Sprite
 ld ix,play2+2
 ld b,28
 call Rev16
 ld hl,CleanChar
 ld de,P_Op3
 ld bc,18
 ldir
Clear_Char2:
 ld bc,$5024
 ld hl,play2
 jp PutSprite16
 
Reverse_Sprite:
 ld c,(hl)
 call FixC2
 call FixC2
 call FixC2
 call FixC2
 ld (hl),a
 inc hl
 djnz Reverse_Sprite
 ret

FixC2:
 rlc c
 rra
 rlc c
 rra
 ret

Rev16:
 ld d,(ix)
 ld e,(ix+1)
 ld (ix),e
 ld (ix+1),d
 inc ix
 inc ix
 djnz Rev16
 ret
 
Really_Start:
 call ClrBG
 ld hl,BGpic
 ld de,$F700
 call DspRLE
 call _clrLCD
 call Black_Band
 ld bc,$0505
 ld (Vegetaxy),bc
 ld (VegetaxyOld),bc
 ld hl,play1
 call PutSprite16
 xor a
 ld (IsFire),a
 ld bc,$5F05
 ld (Kakarotxy),bc
 ld (KakarotxyOld),bc
 ld hl,play2
 call PutSprite16
 xor a
 ld (IsFireG),a
 ld a,30
 ld (VegetaP),a
 ld a,97
 ld (KakarotP),a
 xor a
 ld (Kakarot_counter),a

GameKeyLoop:
 ld a,(difficulty_mode)
 ld b,a
 or a
 jr z,very_hard_mode
diffloop:
 halt
 djnz diffloop
very_hard_mode:
 call _GetKy
 cp K_PLUS
 call z,c_up
 cp K_MINUS
 call z,c_down
 ld a,126
 out (1),a
 in a,(1)
 bit 3,a
 push af
 call z,MoveUP
 pop af
 bit 2,a
 push af
 call z,MoveRIGHT
 pop af
 bit 1,a
 push af
 call z,MoveLEFT
 pop af
 bit 0,a
 call z,MoveDOWN
 ld a,63
 out (1),a
 in a,(1)
 bit 5,a
 push af
 call z,Fire
 pop af
 bit 6,a
 jp z,EXIT
 bit 7,a
 jp z,PauseGame
 call moveFireball

Moves_Kakarot_Randomly:
 ld a,(difficulty_mode)
 ld b, a
 or a
 jr z,very_hard_mode2
diffloop2:
 halt
 djnz diffloop2
very_hard_mode2:
 call KakarotFIRES
 ld a,(Kakarot_counter)
 or a
 jr z,new_direction
 ld a,(Kakarot_direction)
 cp 1
 call z,MoveKakarotLeft
 ld a,(Kakarot_direction)
 cp 2
 call z,MoveKakarotRight
 ld a,(Kakarot_direction)
 cp 3
 call z,MoveKakarotUp
 ld a,(Kakarot_direction)
 cp 4
 call z,MoveKakarotDown
 ld hl,Kakarot_counter
 dec (hl)
 jp GameKeyLoop
new_direction:
 ld a,r
 and 3
 inc a
 ld (Kakarot_direction),a
 ld a,10
 ld (Kakarot_counter),a
 jp GameKeyLoop

OpenGray:
 res 2,(iy+$23)
 ld hl,IntRoutine
 ld de,_alt_int_chksum+1
 ld bc,InterruptMemEnd-IntRoutine
 ldir
 ld a,(_alt_int_chksum+1)
 ld hl,_alt_int_chksum+($28*1)
 add a,(hl)
 ld hl,_alt_int_chksum+($28*2)
 add a,(hl)
 ld hl,_alt_int_chksum+($28*3)
 add a,(hl)
 ld hl,_alt_int_chksum+($28*4)
 add a,(hl)
 ld hl,_alt_int_chksum+($28*5)
 add a,(hl)
 ld (_alt_int_chksum),a
 xor a
 ld (IntCounter), a
 ld (UserCounter), a
 ld de,IntData
 ld hl,SourceIntData
 ld bc,2
 ldir
 set 2,(iy+$23)
 ret

IntRoutine:
 push af
 push hl
 in a,(3)
 bit 1,a
 jr z,EndIntRoutine
 ld hl,UserCounter
 inc (hl)
 ld hl,IntData
 ld a,(IntCounter)
 cp 5
 jr z,DisplayLast
 cp 3
 jr c,DisplayBpl1
 jr DisplayBpl2

DisplayBpl1:
 inc a
 ld (IntCounter),a
 ld a,(hl)
 out (0),a
 jr EndIntRoutine

DisplayBpl2:
 inc a
 ld (IntCounter),a
 inc hl
 ld a,(hl)
 out (0),a
 jr EndIntRoutine

DisplayLast:
 ld a, (hl)
 out (0), a
 xor a
 ld (IntCounter),a

EndIntRoutine:
 ld a,(UserCounter)
 cp 41
 jr z,EndIntRoutine2
 pop hl
 pop af
 ret
EndIntRoutine2:
 xor a
 ld (UserCounter),a
 pop hl
 pop af
 ret
InterruptMemEnd:

KakarotFIRES:
 call FireG
 jp moveFireballG

Collision_DetectionG:
 ld a,(Vegetaxy)
 ld b,a
 ld a,(FireGxy)
 sub b
 cp 23
 ret nc
 
 ld a,(Vegetaxy+1)
 ld b,a
 ld a,(FireGxy+1)
 sub b
 sub 13
 cp 3
 ret nc
 
 ld a,(VegetaP)
 ld d,61
 ld e,a
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 inc e
 inc d
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 inc d
 dec e
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 ld hl,VegetaP
 dec (hl)
 ld a,(hl)
 or a
 ret nz
 pop bc
 pop bc
 pop bc
 jp ContinuePrg

Collision_Detection:
 ld a,(Kakarotxy)
 ld b,a
 ld a,(Firexy)
 sub b
 cp 23
 ret nc
 ld a,(Kakarotxy+1)
 ld b, a
 ld a,(Firexy+1)
 add a,16
 sub b
 cp 3
 ret nc
 ld a,(KakarotP)
 ld d,61
 ld e,a
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 dec e
 inc d
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 inc d
 inc e
 call FindPixel
 cpl
 and (hl)
 ld (hl),a
 ld hl, KakarotP
 inc (hl)
 ld a,(hl)
 cp 128
 ret nz
 pop bc
 pop bc
 pop bc
 jp Winner
 
FindPixel:
 ld hl,FP_Bits
 ld a,e
 and 7
 add a,l
 ld l,a
 adc a,h
 sub l
 ld h,a
 ld c,(hl)
 ld hl,FP_RLD
 ld (hl),d
 ld a,e
 rrca
 rrca   
 rrca
 rld
 or $FC 
 ld l,(hl)
 ld h,a
 ld a,c
 ret

PutSprite16:
 push hl
 ld h,$3F
 ld a,c
 add a,a
 add a,a
 ld l,a
 add hl,hl
 add hl,hl
 ld a,b
 and %00000111
 ld c,a
 inc c
 ld a,b
 rra
 rra
 rra
 and %00011111
 or l
 ld l,a
 pop de
 inc de
 ld a,(de)
 ld b,a
 inc de
 push de
 pop ix
 
DrawLoop:
 push bc
 ld a,(ix)
 inc ix
 ld d,(ix)
 inc ix
 ld e,0
 and a
 rl d
 rla
 ld b,c

RotLoop1:
 rra
 rr d
 rr e
 djnz RotLoop1
 xor (hl)
 ld (hl),a
 ld a,d
 inc hl
 xor (hl)
 ld (hl),a
 ld a,e
 inc hl
 xor (hl)
 ld (hl),a
 ld de,14
 add hl,de
 jr nc,NoWrap
 ld de,$FC00
 add hl,de

NoWrap:
 pop bc
 djnz DrawLoop
 ret
 
MoveKakarotUp:
 ld bc,(Kakarotxy)
 dec c
 ld a,c
 cp 255
 ret z
 ld (Kakarotxy),bc
 jp moveKakarot

MoveKakarotDown:
 ld bc,(Kakarotxy)
 inc c
 ld a,c
 cp 31
 ret nc
 ld (Kakarotxy),bc
 jp moveKakarot

MoveKakarotRight:
 ld bc,(Kakarotxy)
 inc b
 ld a,b
 cp $70
 ret z
 ld (Kakarotxy),bc
 jp moveKakarot
 
MoveKakarotLeft:
 ld bc,(Kakarotxy)
 dec b
 ld a,b
 cp $50
 ret z
 ld (Kakarotxy),bc

moveKakarot:
 ld bc,(KakarotxyOld)
 ld hl,play2
 call PutSprite16
 ld bc,(Kakarotxy)
 ld (KakarotxyOld),bc
 ld hl,play2
 jp PutSprite16
 
MoveRIGHT:
 ld bc,(Vegetaxy)
 inc b
 ld a,b
 cp $30
 ret z
 ld (Vegetaxy),bc
 jr moveVegeta

MoveUP:
 ld bc,(Vegetaxy)
 dec c
 ld a,c
 cp 255
 ret z
 ld (Vegetaxy),bc
 jr moveVegeta

MoveDOWN:
 ld bc,(Vegetaxy)
 inc c
 ld a,c
 cp 31
 ret nc
 ld (Vegetaxy),bc
 jr moveVegeta

MoveLEFT:
 ld bc,(Vegetaxy)
 dec b
 ld a,b
 or a
 ret z
 ld (Vegetaxy),bc

moveVegeta:
 ld bc,(VegetaxyOld)
 ld hl,play1
 call PutSprite16
 ld bc,(Vegetaxy)
 ld (VegetaxyOld),bc
 ld hl,play1
 jp PutSprite16
 
Fire:
 ld hl,IsFire
 xor a
 cp (hl)
 ret nz
 ld (hl),1
 ld hl,(Vegetaxy)
 ld de,$0811
 add hl,de
 ld b, h
 ld c, l
 ld (Firexy),bc
 ld (FirexyOld),bc
 ld hl,Fireball
 jp PutSprite16

FireG:
 ld hl,IsFireG
 xor a
 cp (hl)
 ret nz
 ld (hl),1
 ld hl,(Kakarotxy)
 ld a, l
 add a, 11
 ld c, a
 ld a, h
 sub 8
 ld b, a
 ld (FireGxy),bc
 ld (FireGxyOld),bc
 ld hl,Fireball2
 jp PutSprite16

moveFireball:
 ld hl,IsFire
 xor a
 cp (hl)
 ret z
 ld bc,(Firexy)
 inc b
 inc b
 ld a,111
 cp b
 jr c,fire_hit_wall
 ld (Firexy),bc
 push bc
 call Collision_Detection
 ld bc,(FirexyOld)
 ld hl,Fireball
 push hl
 call PutSprite16
 pop hl
 pop bc
 ld (FirexyOld),bc
 jp PutSprite16

moveFireballG:
 ld hl,IsFireG
 xor a
 cp (hl)
 ret z
 ld bc,(FireGxy)
 dec b
 dec b
 ld a,1
 cp b
 jr nc,fire_hit_wallG
 ld (FireGxy),bc
 push bc
 call Collision_DetectionG
 ld bc,(FireGxyOld)
 ld hl,Fireball2
 push hl
 call PutSprite16
 pop hl
 pop bc
 ld (FireGxyOld),bc
 jp PutSprite16

fire_hit_wall:
 ld bc,(FirexyOld)
 ld hl,Fireball
 call PutSprite16
 xor a
 ld (IsFire),a
 ret

fire_hit_wallG:
 ld bc,(FireGxyOld)
 ld hl,Fireball2
 call PutSprite16
 xor a
 ld (IsFireG),a
 ret
 
Winner:
 call _clrScrn
 ld hl,WinPic
 call SetUp
 jp ContinuePrg

CloseGray:
 res 2,(iy+$23)
 ld a,$3C
 out (0), a
ClearPage:
 ld hl,(Pages)
 call Clear1024
 ld hl,(Pages+2)
Clear1024:
 ld d,h
 ld e,l
 inc de
 ld (hl),0
 ld bc,1024
 ldir
 ret
 
EXIT:
 ld a,$3C
 out (0),a
 call ClrBG
 call CloseGray
 call _clrScrn
 call _homeUp
 res 3,(iy+35)
 jp _JforceCmdNoChar

#include "data128.asm"

.end